Ext.define(
				'DSS.component.WaitForServerStepper',
				{
					extend : 'Ext.window.Window',
					eventNameStart : '',
					eventNameStep : '',
					msgStart : '',
					msgStep : '',
					progressBar : null,
					iSubscriptID : 0,
					iMaxStep : -1,
					constructor : function(config) {
						me = this;

						config.closeAction = 'hide';
						config.modal = true;
						config.closeable = false;
						config.height = 30;
						config.width = 300;
						config.layout = 'fit';
						config.resizable = false;
						config.title = _('Please wait');
						
						if (config.msgStart!=null)
							this.msgStart= _(config.msgStart);
						else
							this.msgStart= _('Please wait, Process is starting up');
						
						if (config.msgStep!=null)
							this.msgStep= _(config.msgStep);
						else
							this.msgStep= _('Executing Step {stepActual} from {stepMaximal}');
						
						this.eventNameStart = config.eventNameStart;
						this.eventNameStep = config.eventNameStep;
						this.endCallback = config.endCallback;
						this.iSubscriptID = 0;

						this.progressBar = Ext.create('Ext.ProgressBar', {
							width : 280
						});

						Ext.apply(me, {
							items : [ {
								xtype : 'panel',
								items : [ this.progressBar ],
								bodyPadding : 5,
								border : 0
							} ],
						});
						this.callParent(arguments);
					},
					step : function(answer) {
						var me = this;
						var fStepperBound = function(answer) {
							me.step(answer);
						}
						var fNextStep = false;
						var result = Ext.JSON.decode(answer);
						if (result.result == null)
							this.end();
						else {
							for ( var eIndex = 0; eIndex < result.result.events.length; eIndex++) {
								var eItem = result.result.events[eIndex];
								switch (eItem.properties.detail) {
								case 'prepare':
									this.iMaxStep = parseFloat(
											eItem.properties.count, 10);
									this.progressBar.updateProgress(0,this.msgStart, false);									
									break;
								case 'step':
									var iStep=eItem.properties.index;
									if (iStep>this.iMaxStep)
										iStep=this.iMaxStep;
									this.progressBar.updateProgress(
											(parseFloat(iStep,
													10) + 1.0)
													/ this.iMaxStep,
											Ext.String.format2(this.msgStep, {
												stepActual : parseFloat(
														iStep,
														10) + 1,
												stepMaximal : this.iMaxStep
											}), false);
									break;
								case 'complete':
									this.end();
									break;
								}
							}
							
						}
					},
					end : function() {
						this.hide();
						if (this.endCallback != null)
							this.endCallback();
					},
					start : function(paramForEvent) {
						this.show();
						var me = this;
						fStepperBound = function(answer) {
							me.step(answer);
						}
						this.progressBar
								.updateProgress(0, this.msgStart, false);
						dss.raiseEvent(me.eventNameStart, paramForEvent);
					}
				});